function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import ReactEchartsCore from '../Core/EchartsReactCore';
import { titleTextStyle, lbLegend, lbGrid } from '../../itemDefaultConfig';
import Empty from '../Empty';
var RadarChart = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref$config = _ref.config,
      title = _ref$config.title,
      tooltip = _ref$config.tooltip,
      legend = _ref$config.legend,
      grid = _ref$config.grid,
      series = _ref$config.series,
      radar = _ref$config.radar,
      otherConfig = _objectWithoutProperties(_ref$config, ["title", "tooltip", "legend", "grid", "series", "radar"]),
      showTitle = _ref.showTitle,
      showLabel = _ref.showLabel,
      EmptyComponent = _ref.empty,
      indicator = _ref.indicator,
      rest = _objectWithoutProperties(_ref, ["config", "showTitle", "showLabel", "empty", "indicator"]);

  var option = _objectSpread({
    title: _objectSpread(_objectSpread({}, titleTextStyle), {}, {
      show: showTitle
    }, title),
    tooltip: _objectSpread({}, tooltip),
    legend: _objectSpread(_objectSpread({
      top: showTitle ? 27 : 'top',
      show: false
    }, lbLegend), legend),
    grid: _objectSpread(_objectSpread({
      top: showTitle ? 66 : 36
    }, lbGrid), grid),
    radar: _objectSpread({
      name: {
        textStyle: {
          color: '#262a30'
        }
      },
      indicator: indicator || []
    }, radar),
    series: series || []
  }, otherConfig);

  var targetArr = [];
  option.series.forEach(function (item) {
    item.type = item.type || 'radar';
    targetArr = targetArr.concat(item.data || []);
  }); // const maxNum = targetArr.length ? Math.max(...targetArr) : 0
  // option.radar.indicator.forEach((item) => {
  //   item.max = maxNum
  // })

  if (!targetArr.length) {
    return EmptyComponent ? /*#__PURE__*/React.createElement(EmptyComponent, null) : /*#__PURE__*/React.createElement(Empty, null);
  }

  return /*#__PURE__*/React.createElement(ReactEchartsCore, _extends({
    notMerge: true,
    config: option,
    ref: ref
  }, rest));
});
RadarChart.propTypes = {
  theme: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  showTitle: PropTypes.bool,
  showLabel: PropTypes.bool,
  style: PropTypes.object,
  className: PropTypes.string,
  config: PropTypes.shape({
    xAxis: PropTypes.oneOfType([PropTypes.array, PropTypes.object]),
    yAxis: PropTypes.oneOfType([PropTypes.array, PropTypes.object]),
    series: PropTypes.array.isRequired
  }).isRequired,
  opts: PropTypes.shape({
    devicePixelRatio: PropTypes.number,
    renderer: PropTypes.oneOf(['canvas', 'svg']),
    width: PropTypes.oneOfType([PropTypes.number, PropTypes.oneOf([null, undefined, 'auto'])]),
    height: PropTypes.oneOfType([PropTypes.number, PropTypes.oneOf([null, undefined, 'auto'])])
  })
};
RadarChart.defaultProps = {
  style: {},
  classname: '',
  theme: 'macarons',
  showTitle: false,
  showLabel: false,
  config: {
    title: {},
    legend: {},
    toolbox: {},
    grid: {},
    radar: {
      // shape: 'circle',
      name: {
        textStyle: {
          color: '#000'
        }
      },
      indicator: [{
        name: '销售',
        max: 6500
      }, {
        name: '管理',
        max: 16000
      }, {
        name: '信息技术',
        max: 30000
      }, {
        name: '客服',
        max: 38000
      }, {
        name: '研发',
        max: 52000
      }, {
        name: '市场',
        max: 25000
      }]
    },
    series: [{
      name: '预算 vs 开销',
      type: 'radar',
      areaStyle: {
        normal: {}
      },
      data: [{
        value: [4300, 10000, 28000, 35000, 50000, 19000],
        name: '预算分配'
      }, {
        value: [5000, 14000, 28000, 31000, 42000, 21000],
        name: '实际开销'
      }]
    }]
  }
};
export default RadarChart;