"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _EchartsReactCore = _interopRequireDefault(require("../Core/EchartsReactCore"));

var _itemDefaultConfig = require("../../itemDefaultConfig");

var _Empty = _interopRequireDefault(require("../Empty"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var RadarChart = /*#__PURE__*/(0, _react.forwardRef)(function (_ref, ref) {
  var _ref$config = _ref.config,
      title = _ref$config.title,
      tooltip = _ref$config.tooltip,
      legend = _ref$config.legend,
      grid = _ref$config.grid,
      series = _ref$config.series,
      radar = _ref$config.radar,
      otherConfig = _objectWithoutProperties(_ref$config, ["title", "tooltip", "legend", "grid", "series", "radar"]),
      showTitle = _ref.showTitle,
      showLabel = _ref.showLabel,
      EmptyComponent = _ref.empty,
      indicator = _ref.indicator,
      rest = _objectWithoutProperties(_ref, ["config", "showTitle", "showLabel", "empty", "indicator"]);

  var option = _objectSpread({
    title: _objectSpread(_objectSpread({}, _itemDefaultConfig.titleTextStyle), {}, {
      show: showTitle
    }, title),
    tooltip: _objectSpread({}, tooltip),
    legend: _objectSpread(_objectSpread({
      top: showTitle ? 27 : 'top',
      show: false
    }, _itemDefaultConfig.lbLegend), legend),
    grid: _objectSpread(_objectSpread({
      top: showTitle ? 66 : 36
    }, _itemDefaultConfig.lbGrid), grid),
    radar: _objectSpread({
      name: {
        textStyle: {
          color: '#262a30'
        }
      },
      indicator: indicator || []
    }, radar),
    series: series || []
  }, otherConfig);

  var targetArr = [];
  option.series.forEach(function (item) {
    item.type = item.type || 'radar';
    targetArr = targetArr.concat(item.data || []);
  }); // const maxNum = targetArr.length ? Math.max(...targetArr) : 0
  // option.radar.indicator.forEach((item) => {
  //   item.max = maxNum
  // })

  if (!targetArr.length) {
    return EmptyComponent ? /*#__PURE__*/_react["default"].createElement(EmptyComponent, null) : /*#__PURE__*/_react["default"].createElement(_Empty["default"], null);
  }

  return /*#__PURE__*/_react["default"].createElement(_EchartsReactCore["default"], _extends({
    notMerge: true,
    config: option,
    ref: ref
  }, rest));
});
RadarChart.propTypes = {
  theme: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]),
  showTitle: _propTypes["default"].bool,
  showLabel: _propTypes["default"].bool,
  style: _propTypes["default"].object,
  className: _propTypes["default"].string,
  config: _propTypes["default"].shape({
    xAxis: _propTypes["default"].oneOfType([_propTypes["default"].array, _propTypes["default"].object]),
    yAxis: _propTypes["default"].oneOfType([_propTypes["default"].array, _propTypes["default"].object]),
    series: _propTypes["default"].array.isRequired
  }).isRequired,
  opts: _propTypes["default"].shape({
    devicePixelRatio: _propTypes["default"].number,
    renderer: _propTypes["default"].oneOf(['canvas', 'svg']),
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].oneOf([null, undefined, 'auto'])]),
    height: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].oneOf([null, undefined, 'auto'])])
  })
};
RadarChart.defaultProps = {
  style: {},
  classname: '',
  theme: 'macarons',
  showTitle: false,
  showLabel: false,
  config: {
    title: {},
    legend: {},
    toolbox: {},
    grid: {},
    radar: {
      // shape: 'circle',
      name: {
        textStyle: {
          color: '#000'
        }
      },
      indicator: [{
        name: '销售',
        max: 6500
      }, {
        name: '管理',
        max: 16000
      }, {
        name: '信息技术',
        max: 30000
      }, {
        name: '客服',
        max: 38000
      }, {
        name: '研发',
        max: 52000
      }, {
        name: '市场',
        max: 25000
      }]
    },
    series: [{
      name: '预算 vs 开销',
      type: 'radar',
      areaStyle: {
        normal: {}
      },
      data: [{
        value: [4300, 10000, 28000, 35000, 50000, 19000],
        name: '预算分配'
      }, {
        value: [5000, 14000, 28000, 31000, 42000, 21000],
        name: '实际开销'
      }]
    }]
  }
};
var _default = RadarChart;
exports["default"] = _default;